package edu.rice.comp322;

import edu.rice.hj.api.HjMetrics;
import edu.rice.hj.runtime.config.HjSystemProperty;
import junit.framework.TestCase;

import static edu.rice.hj.Module0.launchHabaneroApp;

/**
 * Run these tests and observe the results. Why do some tests fail? Observe the output. What happens to the ideal
 * parallelism?
 *
 * @author Matt Bernhard
 */
public class Search2Test extends TestCase {

    public void testSimple() {
        System.out.println("Search2Test.testSimple() starts...");

        final char[] pattern = "rabrabracad".toCharArray();
        final char[] input = "abacadarabrabracadbrabracabracadababacadabrarabrabracadbracabracadabrabrabracad".toCharArray();

        HjSystemProperty.abstractMetrics.setProperty(true);
        final HjMetrics[] results = new HjMetrics[2];

        launchHabaneroApp(() -> {
            results[0] = Search2.executeSearchSeq(pattern, input);
        });

        launchHabaneroApp(() -> {
            results[1] = Search2.executeSearchPar(pattern, input);
        });

        assertTrue("Work: Expected = " + results[0].totalWork() + ", actual = " + results[1].totalWork(), results[1].totalWork() == results[0].totalWork());
        assertTrue("CPL: Expected max = " + results[0].criticalPathLength() + ", actual = " + results[1].criticalPathLength(), results[1].criticalPathLength() <= results[0].criticalPathLength());

        final double speedup = (1.0 * results[0].criticalPathLength()) / results[1].criticalPathLength();
        assertTrue("Speedup must be at least 1.5, actual " + speedup, speedup > 1.5);

        System.out.println("Lab1Test.testSimple() ends.");
    }


}
